﻿//using System.Collections;
//using System.Collections.Generic;
using UnityEditor;
using UnityEngine;


[CustomEditor(typeof(AudioCue), true)]
public class AudioCueEditor : Editor
{
    [SerializeField]
    private AudioSource _previewer;

    public void OnEnable()
    {
        _previewer = EditorUtility
            .CreateGameObjectWithHideFlags("Audio preview", HideFlags.HideAndDontSave, typeof(AudioSource))
            .GetComponent<AudioSource>();
    }

    public void OnDisable()
    {
        DestroyImmediate(_previewer.gameObject);
    }

    public override void OnInspectorGUI()
    {
        DrawDefaultInspector();

        EditorGUI.BeginDisabledGroup(serializedObject.isEditingMultipleObjects);
        if (GUILayout.Button("Preview"))
        {
            ((AudioCue)target).Play(_previewer);
        }

        EditorGUI.EndDisabledGroup();
    }

}
