﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SimpleMusicPlayer : MonoBehaviour
{
    public float startDelayTime = 0.5f;
    public float fadeInDuration = 2f;
    private float targetVolume = 0;
    
    private AudioSource audSrc;

    private float startTime = 0f;
    private bool hasStarted = false;


    void Awake()
    {
        audSrc = GetComponent<AudioSource>();
        // record the target volume to fade in to
        
        
    }

    private void Start()
    {
        // record the time that this object was activated  (to measure delay, and fade in from this point)
        startTime = Time.time;
        targetVolume = audSrc.volume;
        audSrc.volume = 0f;
    }

    private void Update()
    {
        if (hasStarted == false)
        {
            if (Time.time > startTime + startDelayTime)
            {
                MusicPlayerStart();
                StartCoroutine("FadeVolumeUp", fadeInDuration);
                hasStarted = true;
            }
        }
        
    }


    void MusicPlayerStart()
    {
        if (audSrc != null)
        {
            audSrc.Play();
        }
    }


    private IEnumerator FadeVolumeUp(float fadeInDuration)
    {
        while (Time.time < startTime + startDelayTime + fadeInDuration)
        {
            float elapsedTime = Time.time - startTime - startDelayTime;
            audSrc.volume = Mathf.Lerp(0, targetVolume, (elapsedTime / fadeInDuration));
            //Debug.Log(elapsedTime + "  (" + (elapsedTime / fadeInDuration) + ")");
            yield return null;
        }
        // Make sure we got there
        audSrc.volume = targetVolume;
        yield return null;
    }


}
